<?php
// $Id: guestbook.php,v 1.1 2002/11/17 14:48:45 schup Exp $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2001 by the Post-Nuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Peter Schbl, schup@users.sourceforge.net
// Purpose of file:  Block for showing the last x entries in PostGuestbook (http://postguestbook.sourceforge.net)
// based on code of the PostNuke Template module
// ----------------------------------------------------------------------

/**
 * initialise block
 */
function postguestbook_guestbookblock_init()
{
   // Security
   pnSecAddSchema('postguestbook:guestbookblock:', 'Block title::');
}

/**
 * get information on block
 */
function postguestbook_guestbookblock_info()
{
   // Values
   return array('text_type' => 'last_entries',
               'module' => 'postguestbook',
               'text_type_long' => _GBBLOCK_LONGINFO,
               'allow_multiple' => true,
               'form_content' => false,
               'form_refresh' => false,
               'show_preview' => true);
}

/**
 * display block
 */
function postguestbook_guestbookblock_display($blockinfo)
{
    // Security check
    if (!pnSecAuthAction(0,
                         'postguestbook:guestbookblock:',
                         "$blockinfo[title]::",
                         ACCESS_READ)) {
        return;
    }

    // Get variables from content block
    $vars = pnBlockVarsFromContent($blockinfo['content']);

    // Defaults
    if (empty($vars['numitems'])) {
        $vars['numitems'] = 5;
    }
    if (empty($vars['message_maxlength'])) {
       $vars['message_maxlength'] = 50;
    }
    // Database information
    //pnModDBInfoLoad('postguestbook');

    // Create output object
    $output = new pnHTML();
    $output->SetInputMode(_PNH_VERBATIMINPUT);
	 $modinfo = pnModGetInfo(pnModGetIDFromName('postguestbook'));
	 $moddir = "modules/$modinfo[directory]";
	 
    if (!pnModAPILoad('postguestbook', 'user'))
    {
        $output->Text('Failed to load postguestbook User API');
    }
    else
    {
       $showPrivate = false;
       if (pnSecAuthAction(0, 'postguestbook::', '::', ACCESS_ADMIN))
       {
          $showPrivate = true;
       }
       $owner_uid = -1; // no user guestbooks
       //$output->Text("Gstebucheintrge");
       $entries = postguestbook_userapi_getEntries(array('page'        => 1,
                                                         'showPrivate' => $showPrivate,
                                                         'entryCount'  => $vars['numitems'],
                                                         'owner_uid' => $owner_uid));
       // format entries for display
       $maxlength = (int) $vars['message_maxlength'];
		 $output->Text("<table border=\"0\">");
       foreach ($entries as $entry)
       {
           $entry->prepForDisplay();
			  $imgSrc = "$moddir/images/ico_sphere.gif";
			  $output->Text("<tr valign=\"top\"><td rowspan=\"2\"><img src=\"$imgSrc\" alt=\"*\" width=\"8\" height=\"8\"></td><td>");
           $output->Text("<b>$entry->name</b>");
			  $output->Text("</td></tr><tr><td>");
           $message = strip_tags($entry->message); // strip html formating (images, bold, ..)
           //$message = $entry->message;
           // limit message string in length
           if (strlen($message) > $maxlength)			  
           {
              $message = substr($message, 0, $maxlength);
              $message .= "...";
           }
			  
			  
           $output->Text($message);
           $output->Text("<br><br>");
			  $output->Text("</td></tr>");
       }
		 $output->Text("<tr><td colspan=\"2\" align=\"center\">");
		 $view_url = pnModUrl('postguestbook','user','view');
       $output->Text("<a href=\"$view_url\">" . _GOTO_GUESTBOOK ."</a><br>");
		 $output->Text("</td></tr>");
		 $output->Text("</table>");
       
    }
    // Populate block info and pass to theme
    $blockinfo['content'] = $output->GetOutput();
    return themesideblock($blockinfo);
}


/**
 * modify block settings
 */
function postguestbook_guestbookblock_modify($blockinfo)
{
    // Create output object
    $output = new pnHTML();

    // Get current content
    $vars = pnBlockVarsFromContent($blockinfo['content']);

    // Defaults
    if (empty($vars['numitems'])) {
        $vars['numitems'] = 5;
    }
    if (empty($vars['message_maxlength'])) {
       $vars['message_maxlength'] = 50;
    }

    // Create row
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(_NUMITEMS);
    $row[] = $output->FormText('numitems',
                               pnVarPrepForDisplay($vars['numitems']),
                               5,
                               5);
     $output->SetOutputMode(_PNH_KEEPOUTPUT);
     $output->SetInputMode(_PNH_VERBATIMINPUT);
     $output->TableAddRow($row, 'left');

    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(_MESSAGE_MAXLENGTH);
    $row[] = $output->FormText('message_maxlength',
                               pnVarPrepForDisplay($vars['message_maxlength']),
                               5,
                               5);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);

    // Add row
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddRow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Return output
    return $output->GetOutput();
}

/**
 * update block settings
 */
function postguestbook_guestbookblock_update($blockinfo)
{
    $vars['numitems'] = pnVarCleanFromInput('numitems');
    $vars['message_maxlength'] = pnVarCleanFromInput('message_maxlength');
    $blockinfo['content'] = pnBlockVarsToContent($vars);
    return $blockinfo;
}
?>
