<?php
// $Id: pnuserapi.php,v 1.12 2002/11/03 16:01:52 schup Exp $
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//error_reporting(E_ALL);
// <security msg="check for direct call">
if (!function_exists('pnModGetVar'))
{
    die ("You can't access this file directly...");
}
// </security>

// <change msg="include global language file of this module">
$modinfo = pnModGetInfo(pnModGetIDFromName('postguestbook'));
$currentlang = pnUserGetLang();
include_once("modules/$modinfo[directory]/pnlang/$currentlang/global.php");
// </change>

class GuestBookEntry
{
   /** primary key - automatic number */
   var $id;

   /** id of the owner, if used for user guestbooks */
   var $owner_uid;
   /** name of the poster */
   var $name;
   /** optioal, email of the poster */
   var $email;
   /** ip of the poster */
   var $ip;
   /** the message */
   var $message;
   /** comment from admin */
   var $comment;
   /** optioal, url posted by the signer */
   var $homepage;
   /** Date/time when this post was sent */
   var $timestamp;
   /** */
   var $members;
   /** Flag to indicate this post as a private message */
   var $private_msg;
   /** optioal, Country / City */
   var $location;
   /** mood of the user -> define moods/assign smilies? */
   var $mood;
   /** general purpose fields -> can be used in templates */
   var $user1;
   var $user2;
   var $user3;
   var $user4;
   var $user5;

   /** flag, is html disable for this post */
   var $disable_html;
   /** flag, is bbcode disabled for this post */
   var $disable_bbcode;
   /** flag, are autolinks disabled for this post */
   var $disable_autolinks;
   /** Id of the user signing the guestbook (if logged in) or null */
   var $pn_uid;

   /** avatar of the user -> fetched from PN via pn_user_id, 'blank.gif' */
   var $avatar;

   /** html-img code for avatar: '<img src="images/avatar/<avatar" border="0" alt=""' */
   var $avatar_img;

   /**
    * html formated homepage link, call updateFormatedFields to update after change of homepage
    */
   var $form_homepage;

   function GuestBookEntry()
   {
      $this->owner_uid = -1;
   }

   /**
   * create the sql-Statement for a select without where
   * @return select statement
   */
   function getSelectStmt($guestbook_table, $guestbook_column)
   {
      if (!isset($guestbook_table) || !isset($guestbook_column))
      {
         pnModDBInfoLoad('postguestbook');
         list($dbconn) = pnDBGetConn();
         $pntable = pnDBGetTables();
         $guestbook_table = $pntable['postguestbook_guestbook'];
         $guestbook_column = &$pntable['postguestbook_guestbook_column'];
      }

      $sql = "SELECT $guestbook_column[id],
                     $guestbook_column[owner_uid],
                     $guestbook_column[name],
                     $guestbook_column[email],
                     $guestbook_column[ip],
                     $guestbook_column[message],
                     $guestbook_column[comment],
                     $guestbook_column[homepage],
                     $guestbook_column[timestamp],
                     $guestbook_column[members],
                     $guestbook_column[private_msg],
                     $guestbook_column[location],
                     $guestbook_column[mood],
                     $guestbook_column[user1],
                     $guestbook_column[user2],
                     $guestbook_column[user3],
                     $guestbook_column[user4],
                     $guestbook_column[user5],
                     $guestbook_column[disable_html],
                     $guestbook_column[disable_bbcode],
                     $guestbook_column[disable_autolinks],
                     $guestbook_column[pn_uid]
               FROM  $guestbook_table";
      return $sql;
   }

   /**
    * Befllt die formatierten Felder neu.
    * -> immer nach einer nderung der Daten notwendig, wenn die
    *    formatierten Felder verwendet werden
    */
   function updateFormatedFields()
   {
      $this->homepage=trim($this->homepage);
      // <msg date="15.09.2002" msg="I don't understand this statement any more!!??">
      //if (strlen($this->homepage) > 0 && strncmp($this->homepage, "http", 4) != 0)
      // </msg>
      if (strlen($this->homepage) > 0)
      {
         // homepage is set, check if it starts with http(s)
         if (strncmp($this->homepage, 'http', 4) != 0) // faengt nicht mit http (bzw https) an
         {
            $this->homepage = 'http://' . $this->homepage;
         }
         $this->form_homepage = '<a href="' . $this->homepage . '" target="_blank">';
         $this->form_homepage .= $this->homepage . '</a>';
      }
      else
      {
         $this->form_homepage = "";
      }

      // <feature msg="get signers avatar">
      if (strlen($this->pn_uid) > 0 && ((int) $this->pn_uid) > 0)
      {
         $this->avatar = pnUserGetVar('pn_user_avatar', $this->pn_uid);
         // can the avatar be empty ??
         $avatar = '<img src="images/avatar/';
         $avatar .= $this->avatar;
         $avatar .= '" border="0" alt=""/>';
         $this->avatar_img = $avatar;

      }
      else
      {
         // no avatar
      }
      // </feature>
   }

   /**
   * prepare all members for storage.
   */
   function prepForStore()
   {
      list($this->id,
           $this->owner_uid,
           $this->name,
           $this->email,
           $this->ip,
           $this->message,
           $this->comment,
           $this->homepage,
           $this->timestamp,
           $this->members,
           $this->private_msg,
           $this->location,
           $this->mood,
           $this->user1,
           $this->user2,
           $this->user3,
           $this->user4,
           $this->user5,
           $this->disable_html,
           $this->disable_bbcode,
           $this->disable_autolinks,
           $this->pn_uid) = pnVarPrepForStore($this->id,
                                           $this->owner_uid,
                                           $this->name,
                                           $this->email,
                                           $this->ip,
                                           $this->message,
                                           $this->comment,
                                           $this->homepage,
                                           $this->timestamp,
                                           $this->members,
                                           $this->private_msg,
                                           $this->location,
                                           $this->mood,
                                           $this->user1,
                                           $this->user2,
                                           $this->user3,
                                           $this->user4,
                                           $this->user5,
                                           $this->disable_html,
                                           $this->disable_bbcode,
                                           $this->disable_autolinks,
                                           $this->pn_uid);

      if (strlen($this->disable_html) == 0)
      {
         $this->disable_html = 'N';
      }
      if (strlen($this->disable_bbcode) == 0)
      {
         $this->disable_bbcode = 'N';
      }
      if (strlen($this->disable_autolinks) == 0)
      {
         $this->disable_autolinks = 'N';
      }
   }

   /**
    * prepare all members for storage.
    */
   function prepForDisplay()
   {
      list($this->id,
           $this->owner_uid,
           $this->name,
           $this->ip,
           $this->timestamp,
           $this->members,
           $this->private_msg,
           $this->location,
           $this->mood,
           $this->user1,
           $this->user2,
           $this->user3,
           $this->user4,
           $this->user5,
           $this->disable_html,
           $this->disable_bbcode,
           $this->disable_autolinks,
           $this->pn_uid) = pnVarPrepForDisplay($this->id,
                                           $this->owner_uid,
                                           $this->name,
                                           $this->ip,
                                           $this->timestamp,
                                           $this->members,
                                           $this->private_msg,
                                           $this->location,
                                           $this->mood,
                                           $this->user1,
                                           $this->user2,
                                           $this->user3,
                                           $this->user4,
                                           $this->user5,
                                           $this->disable_html,
                                           $this->disable_bbcode,
                                           $this->disable_autolinks,
                                           $this->pn_uid);
      // don't prepare e-mail and homepage
      // homepage-url and email are validated on input
      // and should be ok
      // \todo: check for javascript in url ???
      //$this->homepage;
      //$this->email;

      // enable/disable using of html-code in message      /
      // only html that is allowed (PN-Configuration) ist left untouched,
      // if enable_html ist set to 1

      $html_disabled_by_user = false;
      if (strlen($this->disable_html) > 0 && $this->disable_html == 'Y')
      {
         $html_disabled_by_user = true;
      }
      if (! $html_disabled_by_user && pnModGetVar('postguestbook', 'enable_html'))
      {
         $this->message = pnVarPrepHTMLDisplay($this->message);
      }
      else
      {
         // no html code in message is allowed
         $this->message = pnVarPrepForDisplay($this->message);
      }

      $this->comment = pnVarPrepHTMLDisplay($this->comment);

      $this->updateFormatedFields();

      // after checking html - convert bbcode

      // <feature msg="bbcode">
      // postbbcode has to be activated
      $bbcode_disabled_by_user = false;
      if (strlen($this->disable_bbcode) > 0 && $this->disable_bbcode == 'Y')
      {
         $bbcode_disabled_by_user = true;
      }
      if (pnModGetVar('postguestbook', 'enable_bbcode') == '1' &&
			 pnModAvailable('postbbcode'))
      {
         $html = $this->message;
         if (pnModAPILoad('postbbcode', 'user'))
         {
            // convert bbcode to html
            if (!$bbcode_disabled_by_user)
            {
               $html = pnModAPIFunc('postbbcode', 'user', 'bbtohtml', array("bbcode" => $html));
               if (!isset($html))
               {
                  //$this->message = "bbcode failed - html not set";
                  // -> ignore -> warn admin???
               }
               else
               {
                  $this->message = $html;
               }
            }
            $html =  $this->comment;
            $html = pnModAPIFunc('postbbcode', 'user', 'bbtohtml', array("bbcode" => $html));
            if (isset($html))
            {
                $this->comment = $html;
            }
         }
         else
         {
            // ignore -> bbcode not translated
            // die('Failed to load postbbcode User API');
         }

      }
      // </feature>
      // <feature msg="turn \n into <br />">
      $this->message = nl2br($this->message);
      $this->comment = nl2br($this->comment);
      // </feature>

      // <feature msg="autoformat links">
      $autolinks_disabled_by_user = false;
      if (strlen($this->disable_autolinks) > 0 && $this->disable_autolinks == 'Y')
      {
         $autolinks_disabled_by_user = true;
      }
      if (! $autolinks_disabled_by_user && pnModGetVar('postguestbook', 'enable_autolink'))
      {
         $this->message = postguestbook_userapi_autolink(array('message' => $this->message));
      }
      // </feature>
   }

   function asArray()
   {
      return array('id' => $this->id,
                   'owner_uid' => $this->owner_uid,
                   'name' => $this->name,
                   'email' => $this->email,
                   'ip' => $this->ip,
                   'message' => $this->message,
                   'comment' => $this->comment,
                   'homepage' => $this->homepage,
                   'timestamp' => $this->timestamp,
                   'members' => $this->members,
                   'private_msg' => $this->private_msg,
                   'location' => $this->location,
                   'mood' => $this->mood,
                   'user1' => $this->user1,
                   'user2' => $this->user2,
                   'user3' => $this->user3,
                   'user4' => $this->user4,
                   'user5' => $this->user5,
                   'disable_html' => $this->disable_html,
                   'disable_bbcode' => $this->disable_bbcode,
                   'disable_autolinks' => $this->disable_autolinks,
                   'pn_uid' => $this->pn_uid);
   }
}

/**
 * get a specific item
 * @param $args['id'] id of item to get
 * @returns array
 * @return GuestBook Instance, or false on failure
 */
function postguestbook_userapi_get($args)
{
   // Get arguments from argument array - all arguments to this function
   // should be obtained from the $args array, getting them from other places
   // such as the environment is not allowed, as that makes assumptions that
   // will not hold in future versions of PostNuke
   extract($args);

   // Argument check - make sure that all required arguments are present, if
   // not then set an appropriate error message and return
   if (!isset($id))
   {
      pnSessionSetVar('errormsg', _MODARGSERROR);
      return false;
   }

   // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
   // return arrays but we handle them differently.  For pnDBGetConn() we
   // currently just want the first item, which is the official database
   // handle.  For pnDBGetTables() we want to keep the entire tables array
   // together for easy reference later on
   list($dbconn) = pnDBGetConn();
   $pntable = pnDBGetTables();

   // It's good practice to name the table and column definitions you are
   // getting - $table and $column don't cut it in more complex modules

   $guestbook_table = $pntable['postguestbook_guestbook'];
   $guestbook_column = &$pntable['postguestbook_guestbook_column'];
   // Get item - the formatting here is not mandatory, but it does make the
   // SQL statement relatively easy to read.  Also, separating out the sql
   // statement from the Execute() command allows for simpler debug operation
   // if it is ever needed

   $entry = new GuestBookEntry();
   $sql = $entry->getSelectStmt($guestbook_table, $guestbook_column);
   $sql .= "  WHERE $guestbook_column[id] = " . pnVarPrepForStore($id);
   $result = $dbconn->Execute($sql);

   // Check for an error with the database code, and if so set an appropriate
   // error message and return
   if ($dbconn->ErrorNo() != 0)
   {
      return false;
   }

   // Check for no rows found, and if so return
   if ($result->EOF)
   {
      return false;
   }

   // Obtain the item information from the result set
   list($entry->id,
      $entry->owner_uid,
      $entry->name,
      $entry->email,
      $entry->ip,
      $entry->message,
      $entry->comment,
      $entry->homepage,
      $entry->timestamp,
      $entry->members,
      $entry->private_msg,
      $entry->location,
      $entry->mood,
      $entry->user1,
      $entry->user2,
      $entry->user3,
      $entry->user4,
      $entry->user5,
      $entry->disable_html,
      $entry->disable_bbcode,
      $entry->disable_autolinks,
      $entry->pn_uid) = $result->fields;
   // All successful database queries produce a result set, and that result
   // set should be closed when it has been finished with
   $result->Close();
   $entry->updateFormatedFields();

   // Security check - important to do this as early on as possible to avoid
   // potential security holes or just too much wasted processing.  Although
   // this one is a bit late in the function it is as early as we can do it as
   // this is the first time we have the relevant information
   // <todo date="30.11.2002" msg="rethink permissions" />
   if (!pnSecAuthAction(0, 'postguestbook::', "$entry->name::$entry->id", ACCESS_READ))
   {
      return false;
   }

   return $entry;
}



/**
* get a List of Guestbook entries.
* @param page Page at which to start, 0=first
* @param entryCount Number of Entries to display, defaults to 'entries_per_page=20'
* @param showPrivate 0/not set = don't show, 1=show private messages
* @param owner_uid, optional, pn_user_id of the user, the guestbook belongs to or -1 for default guestbook
* @param gb_id get a single entry (ignoring other parameters)
* @return Array with GuestBookEntry-Instances
*/
function postguestbook_userapi_getEntries($args)
{
   extract($args);
   if (!isset($page))
   {
      $page = 1;
   }
   if (!isset($entryCount))
   {
      $entryCount = pnModGetVar('postguestbook', 'entries_per_page');
   }

   // show private Messages -> only for admin
   if (!isset($showPrivate))
   {
      $showPrivate = false;
   }

   $startIndex = ($page-1) * $entryCount;

   pnModDBInfoLoad('postguestbook');
   list($dbconn) = pnDBGetConn();
   $pntable = pnDBGetTables();
   $guestbook_table = $pntable['postguestbook_guestbook'];
   $guestbook_column = &$pntable['postguestbook_guestbook_column'];

   $entry = new GuestBookEntry();
   $sql = $entry->getSelectStmt($guestbook_table, $guestbook_column);
   $where_conditions = array();
   // <feature id="ignore_private_msg">
   if (! $showPrivate)
   {
      array_push($where_conditions, " $guestbook_column[private_msg] = 0");
   }
   // </feature>
   // <feature id="user_guestbooks">
   if (!isset($owner_uid) || $owner_uid <= 0)
   {
      array_push($where_conditions, " $guestbook_column[owner_uid] = -1");
   }
   else
   {
      array_push($where_conditions, " $guestbook_column[owner_uid] = $owner_uid");
   }
   // </feature>
   // <feature id="get_single_entry">
   if (isset($gb_id))
   {
       $where_conditions = array();
       array_push($where_conditions, " $guestbook_column[id] = $gb_id");
       // if not admin don't allow access to private messages
        if (!pnSecAuthAction(0, 'postguestbook::', '::', ACCESS_ADMIN))
        {
           array_push($where_conditions, " $guestbook_column[private_msg] = 0");
        }
   }
   // </feature>
   // add all condition
   $where_condition = "";
   foreach ($where_conditions as $act_condition)
   {
      if ($where_condition == "")
      {
         $where_condition .= " WHERE ";
      }
      else
      {
         $where_condition .= " AND ";
      }
      $where_condition .= $act_condition;
   }
   $sql .= $where_condition;
   $sql .= " order by $guestbook_column[timestamp] desc";
   $sql .= " LIMIT $startIndex, $entryCount";

   //echo $sql;
   //$result = $dbconn->Execute($sql) or die($dbconn->ErrorNo() . ": ". $dbconn->ErrorMsg() . ":$sql");
   $result = $dbconn->Execute($sql);

   // Check for an error with the database code, and if so set an
   // appropriate error message and return
   if ($dbconn->ErrorNo() != 0)
   {
      pnSessionSetVar('errormsg', _PGB_INSERT_FAILED . "[$sql]");
      return false;
   }

   $entries = array();
   for($e=0; !$result->EOF; $result->MoveNext())
   {
      $entry = new GuestBookEntry();
      list($entry->id,
           $entry->owner_uid,
           $entry->name,
           $entry->email,
           $entry->ip,
           $entry->message,
           $entry->comment,
           $entry->homepage,
           $entry->timestamp,
           $entry->members,
           $entry->private_msg,
           $entry->location,
           $entry->mood,
           $entry->user1,
           $entry->user2,
           $entry->user3,
           $entry->user4,
           $entry->user5,
           $entry->disable_html,
           $entry->disable_bbcode,
           $entry->disable_autolinks,
           $entry->pn_uid) = $result->fields;

      $entry->updateFormatedFields();

      $entries[$e] = $entry;
      $e++;
   }
   return $entries;
}

/**
* get the number of Guestbook entries.
* @param countPrivate 0/not set = don't count, 1=count private messages
* @return Array with GuestBookEntry-Instances
*/
function postguestbook_userapi_getCount($args)
{
   extract($args);
   // show private Messages -> only for admin or user_guestbooks
   if (!isset($showPrivate))
   {
      $countPrivate = false;
   }
   if (!isset($owner_uid))
   {
      $owner_uid = -1;
   }
   //die("getCount for [$owner_uid]");

   pnModDBInfoLoad('postguestbook');
   list($dbconn) = pnDBGetConn();
   $pntable = pnDBGetTables();
   $guestbook_table = $pntable['postguestbook_guestbook'];
   $guestbook_column = &$pntable['postguestbook_guestbook_column'];

   $sql = "SELECT count(*) as pgb_count from $guestbook_table ";
   // <feature id="ignore_private_msg">
   $where_conditions = array();
   if (! $countPrivate) // no private -> ignore them
   {
      array_push($where_conditions, " $guestbook_column[private_msg] = 0");
   }
   else
   {
      // show all
   }
   // </feature>
   // <feature id="user_guestbooks">
   if ($owner_uid <= 0)
   {
      array_push($where_conditions, " $guestbook_column[owner_uid] = -1");
   }
   else
   {
      array_push($where_conditions, " $guestbook_column[owner_uid] = $owner_uid");
   }
   // </feature>
   $where_condition = "";
   foreach ($where_conditions as $act_condition)
   {
      if ($where_condition == "")
      {
         $where_condition .= " WHERE ";
      }
      else
      {
         $where_condition .= " AND ";
      }
      $where_condition .= $act_condition;
   }
   $sql .= $where_condition;
   $result = $dbconn->Execute($sql);
   //$result = $dbconn->Execute($sql) or die($dbconn->ErrorNo() . ": ". $dbconn->ErrorMsg() . ":$sql");

   // Check for an error with the database code, and if so set an
   // appropriate error message and return
   if ($dbconn->ErrorNo() != 0)
   {
      pnSessionSetVar('errormsg', _PGB_INSERT_FAILED . "[$sql]");
      return false;
   }

   list($count) = $result->fields;
   return $count;
}
/**
* create a new Guestbook entry.
* @param GuestBookEntry
*/
function postguestbook_userapi_create($entry)
{
   pnModDBInfoLoad('postguestbook');
   list($dbconn) = pnDBGetConn();
   $pntable = pnDBGetTables();
   $guestbook_table = $pntable['postguestbook_guestbook'];
   $guestbook_column = &$pntable['postguestbook_guestbook_column'];

   $entry->prepForStore();

   if (strlen($entry->pn_uid) == 0)
   {
      $uid = 'NULL';
   }
   else
   {
      $uid = $entry->pn_uid;
   }

   $sql = "INSERT INTO $guestbook_table ($guestbook_column[name],
                                         $guestbook_column[owner_uid],
                                         $guestbook_column[email],
                                         $guestbook_column[ip],
                                         $guestbook_column[message],
                                         $guestbook_column[comment],
                                         $guestbook_column[homepage],
                                         $guestbook_column[members],
                                         $guestbook_column[timestamp],
                                         $guestbook_column[private_msg],
                                         $guestbook_column[location],
                                         $guestbook_column[mood],
                                         $guestbook_column[user1],
                                         $guestbook_column[user2],
                                         $guestbook_column[user3],
                                         $guestbook_column[user4],
                                         $guestbook_column[user5],
                                         $guestbook_column[disable_html],
                                         $guestbook_column[disable_bbcode],
                                         $guestbook_column[disable_autolinks],
                                         $guestbook_column[pn_uid])
                  VALUES ('$entry->name',
                          '$entry->owner_uid',
                          '$entry->email',
                          '$entry->ip',
                          '$entry->message',
                          '$entry->comment',
                          '$entry->homepage',
                          '$entry->members',
                          CURRENT_TIMESTAMP,
                          '$entry->private_msg',
                          '$entry->location',
                          '$entry->mood',
                          '$entry->user1',
                          '$entry->user2',
                          '$entry->user3',
                          '$entry->user4',
                          '$entry->user5',
                          '$entry->disable_html',
                          '$entry->disable_bbcode',
                          '$entry->disable_autolinks',
                          '$uid')";

   //$result = $dbconn->Execute($sql) or die($dbconn->ErrorNo() . ": ". $dbconn->ErrorMsg() . ":$sql");
   $result = $dbconn->Execute($sql);

   // Check for an error with the database code, and if so set an
   // appropriate error message and return
   if ($dbconn->ErrorNo() != 0)
   {
      pnSessionSetVar('errormsg', _PGB_INSERT_FAILED . "[$sql]");
      return false;
   }
   return true;
}

/**
* find guestbook entries.
* @param query_elements - words to search
* @param query_any_all  ('AND', 'OR')
* @param query_startnum page_number if there are more than 10 entries
* @param query_total
* @return array with GuestBookEntries, only some attributes are filled out
*/
function postguestbook_userapi_search($args)
{
   extract($args);
   if (!isset($query_elements))
   {
      $dummy_result = array();
      array_push($dummy_result, 0);
      return $dummy_result;
   }
   if (!isset($query_any_all))
   {
      $query_any_all = "OR";
   }

   if (!isset($query_startnum))
   {
      $query_startnum = 1;
   }

   list($dbconn) = pnDBGetConn();
   $pntable = pnDBGetTables();
   $guestbook_table = $pntable['postguestbook_guestbook'];
   $guestbook_column = &$pntable['postguestbook_guestbook_column'];

   $sql = "SELECT $guestbook_column[id],
                                  $guestbook_column[owner_uid],
                                  $guestbook_column[private_msg],
                                  $guestbook_column[name],
                                  $guestbook_column[timestamp],
                                  $guestbook_column[message]
                      FROM  $guestbook_table
                      WHERE ";

   // show private messages only to admin
   $query = "";
   if (!pnSecAuthAction(0, 'postguestbook::', '::', ACCESS_ADMIN))
   {
      $query .= $guestbook_column[private_msg] . "=0 ";
      if (count($query_elements) > 0)
      {
         $query .= " AND ";
      }
   }

   if ($query_any_all == 'AND')
   {
      $query_any_all = ' AND ';
   }
   else
   {
      $query_any_all = ' OR ';
   }

   foreach($query_elements as $word)
   {
      if (strlen($query) > 0)
      {
         $query .= $query_any_all;
      }
      $query .= '(' ;
      $query .= "$guestbook_column[name] LIKE '$word' OR \n";
      $query .= "$guestbook_column[message] LIKE '$word' OR \n";
      $query .= "$guestbook_column[comment] LIKE '$word' ";
      $query .= ')';
   }

   $sql .= $query;
   $sql .= " ORDER BY $guestbook_column[id] DESC";

   //die("[$sql]");

   if (empty($query_total)) {
      $countres = $dbconn->Execute($sql);
      $query_total = $countres->PO_RecordCount();
      $countres->Close();
   }
   $result = $dbconn->SelectLimit($sql, 10, $query_startnum-1);
   $query_result = array();
   array_push($query_result, $query_total);
   if ($dbconn->ErrorNo() == 0)
   {
      while (!$result->EOF)
      {
         $entry = new GuestBookEntry();
         list($entry->id,
               $entry->owner_uid,
               $entry->private_msg,
               $entry->name,
               $entry->timestamp,
               $entry->message) = $result->fields;

         array_push($query_result, $entry);
         $result->MoveNext();
      }
   }
   return $query_result;
}

/**
* get the ip from the poster.
* -> source: Advanced Guestbook 2.3.1, http://www.proxy2.de
* no params
*/
function postguestbook_userapi_getIp($args)
{
   //extract($args);
   global $HTTP_SERVER_VARS;
   if (isset($HTTP_SERVER_VARS['HTTP_X_FORWARDED_FOR']) && eregi("^[0-9]{1,3}\\.[0-9]{1,3}\\.[0-9]{1,3}\\.[0-9]{1,3}$",$HTTP_SERVER_VARS['HTTP_X_FORWARDED_FOR']))
   {
      $ip = $HTTP_SERVER_VARS['HTTP_X_FORWARDED_FOR'];
   }
   else
   {
      $ip = getenv("REMOTE_ADDR");
   }
   return $ip;
}

/**
* send a email on posting of a new entry.
* @param $args[id] id of the posting
* @param $args[name] name of the poster
* @param $args[message] posted message
*/
function postguestbook_userapi_sendmail($args)
{
   extract($args);
   if ((!isset($name)) ||
      (!isset($message)))
   {
      pnSessionSetVar('errormsg', _MODARGSERROR . "[name=$name, message=$message]");
      return false;
   }

   if (!pnModGetVar('postguestbook', 'notify'))
   {
      // notify not enabled
      return true;
   }

   /* recipients */
   // <bug msg="wrong config variable used">
   // $recipient = pnModGetVar('postguestbook', 'notify_on_new');
   $recipient = pnModGetVar('postguestbook', 'notify_email');
   // </bug>

   // <feature msg="validate e-mail addresses before sending">
   // <note msg="should be cecked in admin when updating config" />
   $recipients = explode(',', $recipient);
   $valid_mails = array();
   $invalid_receiver = false;
   foreach ($recipients as $mail_address)
   {
      $mail_address = trim($mail_address);
      if (pnVarValidate($mail_address, 'email'))
      {
         array_push($valid_mails, $mail_address);
      }
      else
      {
         // not valid -> update config
         $invalid_receiver = true;
      }
   }
   // update config if invalid receiver was found
   if ($invalid_receiver)
   {
      $recipient = implode(',', $valid_mails);
      pnModSetVar('postguestbook', 'notify_email', $recipient);
   }
   // </feature>
   if (strlen(trim($recipient)) == 0)
   {
      // no admin-mail set
      return true;
   }

   /* subject */
   $subject = pnModGetVar('postguestbook', 'notify_subject');

   /* message */
   // <change date="25.10.2002" msg="fix e-mail message">
   // @todo translate
   $mail_message = pnModGetVar('postguestbook', 'notify_message') . "\n\n";
   $mail_message .= "see " . pnModUrl('postguestbook','user','view') . "\n\n";
   $mail_message .= "sender: $name\n";
   $mail_message .= "$message\n";
   $mail_message .= "\n\nThis e-mail is generated and can not be answered!\n";
   // </change>

   /* additional header pieces for errors, From cc's, bcc's, etc */
   //$headers .= 'From: ' . pnGetBaseUrl() . '\n';
   // <change date="12.09.2002" msg="sugested by Oliver Gading">
   $headers  = "Return-Path: " . pnModGetVar('postguestbook', 'notify_from') . "\n";
   $headers .= "From: " . pnModGetVar('postguestbook', 'notify_from') . "\n";
   // </change>
   $headers .= "X-Mailer: PHP\n"; // mailer

   /* If you want to send html mail, uncomment the following line */
   // $headers .= "Content-Type: text/html; charset=iso-8859-1\n"; // Mime type

   /* and now mail it */
   return mail($recipient, $subject, $mail_message, $headers);
}

/**
* auto translation of html-links and e-mail urls.
* @param
*/
function postguestbook_userapi_autolink($args)
{
   if (is_array($args))
   {
      extract($args);
   }
   else
   {
      $message = $args;
   }

   if (!isset($message))
   {
      pnSessionSetVar('errormsg', _MODARGSERROR . "[message=$message]");
      return false;
   }

   $message = preg_replace('/(\s+|(^))(http[s]*:\/\/[!\$\046-\073=\077-\132_\141-\172~]+|(http[s]*:\/\/%[a-f0-9]{2}))+/i',
                           '\1<a href="\3" target="_blank">\3</a>',
                           $message);

   //$regexp = '/((?:[^\s\000-\037\177\(\)<>@,;:\\"\[\]]\.?)+@(?:[^\s\000-\037\177\(\)<>@,;:\\\"\[\]]\.?)+\.[a-z]{2,6})/i';
   //$regexp = '/([a-z0-9.]+@[a-z0-9.]+)/i';
   //$message = preg_replace($regexp, '<a href="mailto:\1">\1</a>', $message);
   //$message = preg_replace('/(http[s]*:\/\/[a-z0-9][a-zA-Z0-9_.\/]*)/si', '<a href="\1" target="_blank">\1</a>', $message);
   return $message;
}
?>
