<?php
// $Id: pnuser.php,v 1.13 2002/11/17 14:47:21 schup Exp $
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html

// include view helper / smarty setup
//error_reporting(E_ALL);
// <security msg="check for direct call">
if (!function_exists('pnModGetVar'))
{
   die ("You can't access this file directly...");
}
// </security>

$modinfo = pnModGetInfo(pnModGetIDFromName('postguestbook'));
// <change msg="include global language file of this module">
$currentlang = pnUserGetLang();
include_once("modules/$modinfo[directory]/pnlang/$currentlang/global.php");
// </change>

// smarty optional
@include "modules/$modinfo[directory]/smarty_view.php";

function postguestbook_user_main()
{
   $output = new pnHTML();

   if (!pnSecAuthAction(0, 'postguestbook::', '::', ACCESS_READ))
   {
        $output->Text(_POSTGUESTBOOKNOAUTH);
        return $output->GetOutput();
   }

   $gb_id = pnVarCleanFromInput('gb_id');
   $param_array = array();
   if (isset($gb_id))
   {
      $param_array = array('gb_id' => $gb_id);
   }

   $output->SetInputMode(_PNH_VERBATIMINPUT);
   $output->Text(postguestbook_user_view($param_array));
   $output->SetInputMode(_PNH_PARSEINPUT);

   return $output->GetOutput();
}

/**
 * default view
 * @param owner_uid - pn_userid for user_guestbooks
 * @param style - overwrite style for user_guestbooks
 */
function postguestbook_user_view($args)
{
   extract($args);
   // Security check - important to do this as early as possible to avoid
   // potential security holes or just too much wasted processing
   if (!pnSecAuthAction(0, 'postguestbook::', '::', ACCESS_OVERVIEW))
   {
      $output->Text(_POSTGUESTBOOKNOAUTH);
      return $output->GetOutput();
   }

   if (!pnModAPILoad('postguestbook', 'user'))
   {
      die('Failed to load postguestbook User API');
   }

   $page = pnVarCleanFromInput('page');
   if (!$page)
   {
      $page = 1;
   }

   $showPrivate = false;
   if (pnSecAuthAction(0, 'postguestbook::', '::', ACCESS_ADMIN))
   {
      $showPrivate = true;
   }
   //$modinfo = pnModGetInfo(pnModGetIDFromName('postguestbook'));

   if (!isset($entryCount))
   {
      $entryCount = pnModGetVar('postguestbook', 'entries_per_page');
   }
   // <feature id="user_guestbooks">
   if (!isset($owner_uid))
   {
      $owner_uid = -1;
   }
   // </feature>

   // calculate Start-Index
   //$startIndex = ($page-1) * $entryCount;
   if (!isset($gb_id))
   {
      $entries = postguestbook_userapi_getEntries(array('page'        => $page,
                                                      'showPrivate' => $showPrivate,
                                                      'entryCount'  => $entryCount,
                                                      'owner_uid' => $owner_uid));

      $count = postguestbook_userapi_getCount(array('countPrivate' => $showPrivate,
                                                    'owner_uid' => $owner_uid));
   }
   else
   {
         $entries = postguestbook_userapi_getEntries(array('gb_id' => $gb_id));
         $count = 1;
   }

   // <part msg="calculate Number of Pages">
   $number_of_pages = $count / $entryCount;
   if ($count % $entryCount)
   {
      $number_of_pages ++;
   }
	if ($number_of_pages < 1) 
	{
		$number_of_pages = 1;
	}
   // </part>

   // <part msg="prepare variables for display">
   $temp_entries = array();
   foreach ($entries as $temp_entry)
   {
      $temp_entry->prepForDisplay();
      array_push($temp_entries, $temp_entry);
   }
   $entries = $temp_entries;
   // </part>

   $modinfo = pnModGetInfo(pnModGetIDFromName('postguestbook'));
   if (!isset($style))
   {
      $style = pnModGetVar('postguestbook', 'style') ;
   }

   include "modules/$modinfo[directory]/styles/$style/style_info.php";

   //if ($style != "internal")
   if ($pgb_styleinfo['typ'] == 'smarty')
   {
      $is_internal = false;
      // init template engine
      $smarty = postguestbook_view_create_smarty();
      $smarty->assign('title', _PGB_TITLE);
      $smarty->assign('pgb_error_message', '');

      $smarty->assign('current_page', $page); // current page, first page = 1
      $smarty->assign('number_of_pages', $number_of_pages);
      $smarty->assign('pages', range(1, $number_of_pages));

      // set template vars
      //$smarty->assign("entry_count", count($entries));
      $smarty->assign('entry_count', $count);
      $smarty->assign('entries', $entries);
   }
   else
   {
      // init non template
      $is_internal = true;
      include "modules/$modinfo[directory]/internal_view.php";
   }


   // start output
   $output = new pnHTML();
   $output->SetInputMode(_PNH_VERBATIMINPUT);
   /*
   if (pnSecAuthAction(0, 'postguestbook::', '::', ACCESS_ADMIN))
   {
      $output->Text('<a href="'. pnModUrl('postguestbook','admin','main') . '">admin</a><br />');
   }
   */
   if ($owner_uid == -1)
   {
      if (!$is_internal)
      {
         if (!isset($gb_id))
         {
            $output->Text($smarty->fetch("$style/header.tpl"));
            $output->Text($smarty->fetch("$style/page_nav.tpl"));
         }
         $output->Text($smarty->fetch("$style/entries.tpl"));
         if (!isset($gb_id))
         {
            $output->Text($smarty->fetch("$style/page_nav.tpl"));
         }
      }
      else
      {
         ob_start();
         if (!isset($gb_id))
         {
            include "$moddir/styles/$style/header.php";
            include "$moddir/styles/$style/page_nav.php";
         }
         include "$moddir/styles/$style/entries.php";
         if (!isset($gb_id))
         {
            include "$moddir/styles/$style/page_nav.php";
         }
         $output->Text(ob_get_contents());
         ob_end_clean();
      }
   }
   else
   {
      // presentation of user-guestbooks
      // think about it
      if (!$is_internal)
      {
         $output->Text($smarty->fetch("$style/entries.tpl"));
      }
      else
      {
         ob_start();
         include "$moddir/styles/$style/entries.php";
         $output->Text(ob_get_contents());
         ob_end_clean();
      }
   }

   $output->Linebreak(2);
   $output->Text(postguestbook_footer());
   $output->SetInputMode(_PNH_PARSEINPUT);

   //$output->SetInputMode(_PNH_VERBATIMINPUT);
   //$output->Text(postguestbook_footer());
   //$output->SetInputMode(_PNH_PARSEINPUT);


   return $output->GetOutput();
}

/**
* get the update-View for a Entry
*/
function postguestbook_user_modify($args)
{
   return postguestbook_user_new($args);
}

/**
*
*/
function postguestbook_user_new($args)
{
   $output = new pnHTML();
   $output->SetInputMode(_PNH_VERBATIMINPUT);
   $error_message = '';

   // check permissions
   // <change msg="disable Authenticatin via config">
   $do_auth_check = pnModGetVar('postguestbook', 'sign_check_by_cms') ;
   if (!isset($do_auth_check) && $do_auth_check == "1")
   {
      if (!pnSecAuthAction(0, 'postguestbook::', '::', ACCESS_COMMENT))
      {
         $output->Text(_POSTGUESTBOOKNOAUTH);
         return $output->GetOutput();
      }
   }
   // </change>

   // are we previewing or committing the guestbookentry?
   $preview = pnVarCleanFromInput('preview') ? true : false;
   $commit  = pnVarCleanFromInput('commit') ? true : false;


   if (!pnModAPILoad('postguestbook', 'user'))
   {
      $output->Text(_PGB_API_LOAD_FAILED);
      return $output->GetOutput();
   }

   $modinfo = pnModGetInfo(pnModGetIDFromName('postguestbook'));
   $style = pnModGetVar('postguestbook', 'style') ;

   include "modules/$modinfo[directory]/styles/$style/style_info.php";

   //if ($style != "internal")
   if ($pgb_styleinfo['typ'] == 'smarty')
   {
      $is_internal = false;
      $smarty = postguestbook_view_create_smarty();
   }
   else
   {
      $is_internal = true;
      include "modules/$modinfo[directory]/internal_view.php";
   }

   // <feature msg="bbcode">
	$bbcode_html = "";
	 
   if (pnModGetVar('postguestbook', 'enable_bbcode') == '1' &&
		 pnModAvailable('postbbcode'))
   {
      if (pnModAPILoad('postbbcode', 'user'))
      {
			// <change msg="don't call html_buttons, if bbcode is disabled">

         $bbcode_html = pnModAPIFunc('postbbcode',
                                    'user',
                                    'html_buttons',
                                    array('form_name' => 'pgb_form',
                                          'control_name' => 'pgb_message'));         

      }
   }
	if (! $is_internal)
	{
		$smarty->assign('pgb_bbcode_html', $bbcode_html);
	}
	else
	{
		$tpl_pgb_bbcode_html = $bbcode_html;
	}
   // </feature>


   if (! $is_internal)
   {
      $smarty->assign("pgb_submit_url", pnModUrl('postguestbook','user','new'));
      $smarty->assign("pgb_authid", pnSecGenAuthKey());
   }
   else
   {
      $tpl_pgb_submit_url = pnModUrl('postguestbook','user','new');
   }

   // check for necessary fields
   list($pgb_name, $pgb_email, $pgb_location) = pnVarCleanFromInput('pgb_name', 'pgb_email', 'pgb_location');
   list($pgb_message, $pgb_homepage) = pnVarCleanFromInput('pgb_message', 'pgb_homepage');
   $pgb_comment = pnVarCleanFromInput('pgb_comment'); // since 0.5
   list($pgb_private_msg, $pgb_mood) = pnVarCleanFromInput('pgb_private_msg', 'pgb_mood');
   list($pgb_user1, $pgb_user2, $pgb_user3) = pnVarCleanFromInput('pgb_user1', 'pgb_user2', 'pgb_user3');
   list($pgb_user4, $pgb_user5) = pnVarCleanFromInput('pgb_user4', 'pgb_user5');
   list($pgb_disable_html, $pgb_disable_bbcode) = pnVarCleanFromInput('pgb_disable_html', 'pgb_disable_bbcode');
   list($pgb_disable_autolinks) = pnVarCleanFromInput('pgb_disable_autolinks');

   // avoid warings when error level is set to E_ALL
   if (!isset($pgb_location)) $pgb_location = '';
   if (!isset($pgb_message)) $pgb_message = '';
   if (!isset($pgb_name)) $pgb_name = '';
   if (!isset($pgb_email)) $pgb_email = '';
   if (!isset($pgb_homepage)) $pgb_homepage = '';
   if (!isset($pgb_private)) $pgb_private = 'N';
   if (!isset($pgb_mood)) $pgb_mood = '';
   if (!isset($pgb_user1)) $pgb_user1 = '';
   if (!isset($pgb_user2)) $pgb_user2 = '';
   if (!isset($pgb_user3)) $pgb_user3 = '';
   if (!isset($pgb_user4)) $pgb_user4 = '';
   if (!isset($pgb_user5)) $pgb_user5 = '';
   if (!isset($pgb_disable_bbcode)) $pgb_disable_bbcode = 'N';
   if (!isset($pgb_disable_html)) $pgb_disable_html = 'N';
   if (!isset($pgb_disable_autolinks)) $pgb_disable_autolinks = 'N';

   // censor message
   // -> ignore bad words in other fields
   if (strlen($pgb_message) > 0)
   {
      $cens_message = pnVarCensor($pgb_message);
      if ($cens_message != $pgb_message)
      {
         // input contains censored word -> notify user ?
         // store censored message in db
         $pgb_message = $cens_message;
      }
   }

   // <feature id="set_current_user_info">
   // set current user values,if values are not set and user is logged in
   // -> name, email, url
   if (! ($commit || $preview) && pnUserLoggedIn())
   {
      if (strlen(trim($pgb_name)) == 0)
      {
         $pgb_name = pnUserGetVar('name');
         if (strlen($pgb_name) == 0)
         {
            $pgb_name = pnUserGetVar('uname');
         }
      }

      if (pnUserLoggedIn() && strlen(trim($pgb_email)) == 0)
      {
         // <change msg="use femail instead of email">
         $pgb_email = pnUserGetVar('femail');
         //$pgb_email = pnUserGetVar('email');
         // </change>
      }

      if (strlen($pgb_homepage) == 0)
      {
         $pgb_homepage = pnUserGetVar('url');
      }
   }
   // <feature>
   $error_message = "";
   if ($commit || $preview)
   {
      // check required fields
      if (strlen($pgb_name) == 0 || strlen($pgb_message) == 0)
      {
         // error
         if (strlen($pgb_name) == 0)
         {
            $error_message = _PGB_ERROR_NAME_MISSING;
         }
         if (strlen($pgb_message) == 0)
         {
            $error_message .= _PGB_ERROR_MESSAGE_MISSING;
         }
      }

      // check email
      if (strlen(trim($pgb_email)) > 0 && !pnVarValidate($pgb_email, 'email'))
      {
         $error_message .= _PGB_ERROR_EMAIL_NOT_VALID;
      }

      // check Homepage
      if (strlen(trim($pgb_homepage)) > 0 && !pnVarValidate($pgb_homepage, 'url'))
      {
         $error_message .= _PGB_ERROR_HOMEPAGE_NOT_VALID;
      }
   }

   // set class values
   $entry = new GuestBookEntry();
   $entry->name = $pgb_name;
   $entry->email = $pgb_email;
   $entry->location = $pgb_location;
   $entry->message = $pgb_message;
   $entry->comment = $pgb_comment;
   $entry->homepage = $pgb_homepage;
   $entry->private_msg = $pgb_private_msg;
   $entry->mood = $pgb_mood;
   $entry->user1 = $pgb_user1;
   $entry->user2 = $pgb_user2;
   $entry->user3 = $pgb_user3;
   $entry->user4 = $pgb_user4;
   $entry->user5 = $pgb_user5;
   $entry->disable_html = $pgb_disable_html;
   $entry->disable_bbcode = $pgb_disable_bbcode;
   $entry->disable_autolinks = $pgb_disable_autolinks;

   if (pnUserLoggedIn())
   {
      $entry->pn_uid = pnUserGetVar('uid');
      //$entry->avatar = pnUserGetVar('user_avatar');
      // -> avatar will be set in updateFormatedFields
   }
   else
   {
      $entry->pn_uid = "";
      $entry->avatar = "";
   }
   $pgb_pn_uid = $entry->pn_uid;
   $entry->ip = postguestbook_userapi_getIp("");
   $entry->updateFormatedFields();

// check if we can save data and do it
   if ($commit && strlen($error_message) ==0)
   {
        // Confirm authorisation code
        if (!pnSecConfirmAuthKey()) {
        include 'header.php';
        echo _BADAUTHKEY;
        include 'footer.php';
        exit;
        }
      // save Data
      if (postguestbook_userapi_create($entry))
      {
         // keine Fehler
         // <feature msg="notify admin of new posting">
         /*
         // does the sending of html-message make any sense?
         $send_html_to_admin=true;
         if ($send_html_to_admin)
         {
            $smarty->assign("entry_count", count(1));
            $smarty->assign("entries", array($entry));
            $html_message = $output->Text($smarty->fetch("entries.tpl");
         }
         */
         $html_message=$entry->message;
         if (pnModGetVar('postguestbook', 'notify'))
         {
            postguestbook_userapi_sendmail(array('name' => $entry->name,
                                                   'message' => $entry->message,
                                                   'html_message' => $html_message));
         }

         // </feature>
         // <bugfix msg="disable reload of post" author="Oliver Gading">
         // return postguestbook_user_main();
         pnRedirect(pnModURL('postguestbook', 'user', 'view'));
         return true;
         // </bugfix>
      }
      else
      {
         // Fehler passiert
         $error_message = _PGB_ERROR_SAVING_ENTRY;
      }
   }


   // <cr msg="show timestamp in preview">
   $entry->timestamp = time();
   // </cr>
   $entry->PrepForDisplay();

   // <feature msg="autoformat links">
   //$entry->message = postguestbook_userapi_autolink(array('message' => $entry->message));
   // </feature>
   if (! $is_internal)
   {
      $smarty->assign('pgb_name', $pgb_name);
      $smarty->assign('pgb_email', $pgb_email);
      $smarty->assign('pgb_location', $pgb_location);
      $smarty->assign('pgb_message', $pgb_message);
      $smarty->assign('pgb_comment', $pgb_comment);
      $smarty->assign('pgb_homepage', $pgb_homepage);
      $smarty->assign('pgb_private_msg', $pgb_private_msg);
      $smarty->assign('pgb_mood', $pgb_mood);
      $smarty->assign('pgb_user1', $pgb_user1);
      $smarty->assign('pgb_user2', $pgb_user2);
      $smarty->assign('pgb_user3', $pgb_user3);
      $smarty->assign('pgb_user4', $pgb_user4);
      $smarty->assign('pgb_user5', $pgb_user5);
      $smarty->assign('pgb_error_message', $error_message);
      $smarty->assign('pgb_timestamp', time());
      $smarty->assign('pgb_disable_html', $pgb_disable_html);
      $smarty->assign('pgb_disable_bbcode', $pgb_disable_bbcode);
      $smarty->assign('pgb_disable_autolinks', $pgb_disable_autolinks);
      $smarty->assign('pgb_pn_uid', $pgb_pn_uid);
      $smarty->assign('pgb_avatar', $entry->avatar); // take from entry, can't be changed
      $smarty->assign('pgb_avatar_img', $entry->avatar_img); // take from entry, can't be changed
   }
   else
   {
      $tpl_pgb_name = $pgb_name;
      $tpl_pgb_email = $pgb_email;
      $tpl_pgb_location = $pgb_location;
      $tpl_pgb_message = $pgb_message;
      $tpl_pgb_comment = $pgb_comment;
      $tpl_pgb_homepage = $pgb_homepage;
      $tpl_pgb_private_msg = $pgb_private_msg;
      $tpl_pgb_mood = $pgb_mood;
      $tpl_pgb_user1 = $pgb_user1;
      $tpl_pgb_user2 = $pgb_user2;
      $tpl_pgb_user3 = $pgb_user3;
      $tpl_pgb_user4 = $pgb_user4;
      $tpl_pgb_user5 = $pgb_user5;
      $tpl_pgb_error_message = $error_message;
      $tpl_pgb_timestamp = time();
      $tpl_pgb_disable_html =  $pgb_disable_html;
      $tpl_pgb_disable_bbcode = $pgb_disable_bbcode;
      $tpl_pgb_disable_autolinks =  $pgb_disable_autolinks;
      $tpl_pgb_pn_uid = $pgb_pn_uid;
      $tpl_pgb_avatar = $entry->avatar; // take from entry, can't be changed
      $tpl_pgb_avatar_img = $entry->avatar_img;
   }

   $style_dir = pnModGetVar('postguestbook', 'style') ;

   $output->SetInputMode(_PNH_VERBATIMINPUT);
   // <feature id="preview_message">
   if ($preview && strlen($error_message) == 0)
   {
      if (! $is_internal)
      {
         $smarty->assign("entry_count", 1);
         $smarty->assign("entries", array($entry));
         $output->Text($smarty->fetch("$style_dir/preview_header.tpl"));
         $output->Text($smarty->fetch("$style_dir/entries.tpl"));
      }
      else
      {
         $tpl_entry_count = 1;
         $tpl_entries = array($entry);

         ob_start();
         include "$moddir/styles/$style/preview_header.php";
         include "$moddir/styles/$style/entries.php";
         $output->Text(ob_get_contents());
         ob_end_clean();
      }
   }
   // </feature>


   if (! $is_internal)
   {
      $output->Text($smarty->fetch("$style_dir/entry_submit.tpl"));
   }
   else
   {
      ob_start();
      include "$moddir/styles/$style/entry_submit.php";
      $output->Text(ob_get_contents());
      ob_end_clean();
   }

   $output->SetInputMode(_PNH_PARSEINPUT);
   return $output->GetOutput();
}


/**
* footer message
*/
function postguestbook_footer()
{
   // lets get the module's information
   $modinfo = pnModGetInfo(pnModGetIDFromName('postguestbook'));

   $footer = '<table width="99%"><tr>';
   if (pnSecAuthAction(0, 'postguestbook::', '::', ACCESS_ADMIN))
   {
      $footer .= '<td align="left"><a href="'. pnModUrl('postguestbook','admin','main') . '">admin</a></td>';
   }
   $footer .= '<td align="right"><font color="#999999">';
   $footer .= 'Powered by: <a href="http://postguestbook.sourceforge.net" target="_blank">';
   $footer .= "PostGuestbook $modinfo[version]</a> by schup ";
   $footer .= 'and Ashnod <a href="http://www.donkamille.de" target="_blank">';
   $footer .='</font></td></tr></table>';
   return $footer;
}
?>
