<?php
// $Id: smarty_view.php,v 1.13 2002/11/17 14:46:43 schup Exp $
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html

// <security msg="check for direct call">
if (!function_exists('pnModGetVar'))
{
   die ("You can't access this file directly...");
}
// </security>


$modinfo = pnModGetInfo(pnModGetIDFromName('postguestbook'));

if (!defined('SMARTY_DIR'))
{
   $smarty_version_to_use = pnModGetVar('postguestbook', 'use_smarty_version');
   $smarty_dir = "smarty";
   if (strlen($smarty_version_to_use) > 0)
   {
      if ($smarty_version_to_use == 'old')
      {
         $smarty_dir = 'smarty201';
      }
   }

   define("SMARTY_DIR", "modules/$modinfo[directory]/$smarty_dir/");
   require_once(SMARTY_DIR."Smarty.class.php");
}

// make sure Theme has been loaded --> color constants are needed
pnThemeLoad(pnUserGetTheme());


/**
* create an new Smarty-instance.
* @return configured smarty instance
*/
function postguestbook_view_create_smarty()
{
   $modinfo = pnModGetInfo(pnModGetIDFromName('postguestbook'));
   $smarty = new Smarty;

   // <fix msg="Encompass compatible" date="13.08.2002>
   // encompass smarty uses '[-' and '-]' as delimiters
   //   -> this is set directly in Smarty.class.php and influences
   //      all other modules using smarty (smarty is only loaded once, theme goes first)
   // encompass uses an older version of smarty -> doesn't support the alternate color
   //      feature of the default templates
   $smarty->left_delimiter  =  '{';
   $smarty->right_delimiter =  '}';
   // </fix>

   $moddir = "modules/$modinfo[directory]";

   // enable differnt styles
   $style = pnModGetVar('postguestbook', 'style');
   if (strlen($style) > 0)
   {
      $smarty->assign('pgb_image_dir', "$moddir/styles/$style/images");
      //$smarty->template_dir = "$moddir/styles/$style/templates";
      $smarty->template_dir = "$moddir/styles";
      //$smarty->compile_dir  = "$moddir/styles/$style/templates_c";
   }
   else
   {
      $smarty->assign('pgb_image_dir',"$moddir/images");
      $smarty->template_dir = "$moddir/smarty/templates";
      //$smarty->compile_dir  = "$moddir/smarty/templates_c";
   }

   // templates_c can be unique, if filenames for smarty are unique
   // -> smary->template_dir has to point to parent-directory of styles
   $smarty->compile_dir  = "$moddir/smarty/templates_c";

   $smarty->config_dir   = "$moddir/smarty/configs";
   $smarty->cache_dir    = "$moddir/smarty/cache";

   $smarty->assign('style', $style);

   $smarty->compile_check = true;
   $smarty->debugging = false;

   // <fix msg="fixes problems with safe mode">
   $smarty->use_sub_dirs = false;
   // </fix>

   //$smarty->default_template_handler_func = "postguestbook_view_tplnotfound";

   $smarty->assign('pgb_moddir', $moddir); // module-directory

   if (pnSecAuthAction(0, 'postguestbook::', '::', ACCESS_ADMIN))
   {
      $smarty->assign("isadmin", true);
   }
   else
   {
      $smarty->assign("isadmin", false);
   }


   global $bgcolor1, $bgcolor2, $bgcolor3, $bgcolor4, $bgcolor5, $bgcolor6;
   global $textcolor1, $textcolor2;
   // alternating Colors for Rows
   $rowcolor = array("$bgcolor2", "$bgcolor3");
   $smarty->assign('rowcolor', $rowcolor);
   $smarty->assign('bgcolor1', $bgcolor1);
   $smarty->assign('bgcolor2', $bgcolor2);
   $smarty->assign('bgcolor3', $bgcolor3);
   $smarty->assign('bgcolor4', $bgcolor4);

   if (pnModAvailable('Encompass'))
   {
      $colors = pnModAPIFunc('Encompass','user','getSkinColors', array());
      $smarty->assign('bgcolor5', $colors['bcolor5']);
      $smarty->assign('bgcolor6', $colors['bcolor6']);
   }
   else
   {
      // use vars if set somewhere else
      $smarty->assign('bgcolor5', $bgcolor5);
      $smarty->assign('bgcolor6', $bgcolor6);
   }
   //

   $smarty->assign('textcolor1', $textcolor1);
   $smarty->assign('textcolor2', $textcolor2);


   $smarty->assign('lang', pnUserGetLang());

   // how can { } be used in smary ?
   // -> smarty defines {ldelim} and {rdelim} for left and right delimiter
   // -> javscript code could be enclosed in a {literal} {/literal} block
   $smarty->assign('curl_open', '{');
   $smarty->assign('curl_close', '}');

   // <feature msg="set open/close table values from theme>
   ob_start();
   OpenTable();
   $smarty->assign('opentable', ob_get_contents());
   ob_end_clean();

   ob_start();
   CloseTable();
   $smarty->assign('closetable', ob_get_contents());
   ob_end_clean();

   ob_start();
   OpenTable2();
   $smarty->assign('opentable2', ob_get_contents());
   ob_end_clean();

   ob_start();
   CloseTable2();
   $smarty->assign('closetable2', ob_get_contents());
   ob_end_clean();
   // </feature>


   $smarty->assign('pgb_start_url', pnModUrl('postguestbook','user','view'));
   $smarty->assign('pgb_submit_url', pnModUrl('postguestbook','user','new'));
   $smarty->assign('pgb_admin_delete_url', pnModUrl('postguestbook','admin','delete'));
   $smarty->assign('pgb_admin_modify_url', pnModUrl('postguestbook','admin','modify'));

   // notify the user with a alert-box about a error
   // -> can be used in template, but hasn't to
   // -> only if error has occured
   $status_msg = pnSessionGetVar("errormsg");
   $status_msg_alert = "";
   if (strlen($status_msg) > 0)
   {
      $status_msg_alert = "<script type=\"text/javascript\"><!--\n";
      $status_msg_alert .= "function showStatus(){\n";
      $status_msg_alert .= "  alert(\"$status_msg\");}\n";
      $status_msg_alert .= " window.setTimeout(\"showStatus()\", 1000);\n";
      $status_msg_alert .= "-->\n</script>\n";
   }
   $smarty->assign('pgb_status_alert', $status_msg_alert);
   $status_msg = pnGetStatusMsg();
   if (!isset($status_msg)) $status_msg = "";
   $smarty->assign('pgb_status', $status_msg);


   // \todo: get from user
   $smarty->assign('pgb_date_format', '%d.%m.%Y %H:%M:%S');

   $smarty->assign('PGB_ON_DATE_FORMAT', _PGB_ON_DATE_FORMAT);//

   // <flags since="0.5">
   $enable_bbcode = false;
   if (pnModGetVar('postguestbook', 'enable_bbcode') == '1' && pnModAvailable('postbbcode'))
   {
      $enable_bbcode = true;
   }
   $smarty->assign('pgb_is_bbcode_enabled', $enable_bbcode);

   $enable_html = false;
   if (pnModGetVar('postguestbook', 'enable_html') == '1')
   {
      $enable_html = true;
   }
   $smarty->assign('pgb_is_html_enabled', $enable_html);


   $enable_autolink = false;
   if (pnModGetVar('postguestbook', 'enable_autolink') == '1')
   {
      $enable_autolink = true;
   }
   $smarty->assign('pgb_is_autolink_enabled', $enable_autolink);
   // </flags>

   // Language constants
   $smarty->assign('PGB_CREATE_ENTRY', _PGB_CREATE_ENTRY);
   $smarty->assign('PGB_ENTRY_COUNT_MSG', _PGB_ENTRY_COUNT_MSG);
   $smarty->assign('PGB_TITLE', _PGB_TITLE);
   $smarty->assign('PGB_WELCOME_MSG', _PGB_WELCOME_MSG);

   $smarty->assign('PGB_FROM', _PGB_FROM);
   $smarty->assign('PGB_WROTE', _PGB_WROTE);
   $smarty->assign('PGB_HOMEPAGE', _PGB_HOMEPAGE);
   $smarty->assign('PGB_EMAIL', _PGB_EMAIL);
   $smarty->assign('PGB_PAGE',  _PGB_PAGE);
   $smarty->assign('PGB_TITLE_ADD_ENTRY', _PGB_TITLE_ADD_ENTRY);
   $smarty->assign('PGB_TITLE_PREVIEW', _PGB_TITLE_PREVIEW);

   $smarty->assign('PGB_EDIT', _PGB_EDIT);
   $smarty->assign('PGB_DELETE', _PGB_DELETE);


   $smarty->assign('PGB_CAP_NAME',      _PGB_CAP_NAME);
   $smarty->assign('PGB_CAP_LOCATION',  _PGB_CAP_LOCATION);
   $smarty->assign('PGB_CAP_HOMEPAGE',  _PGB_CAP_HOMEPAGE);
   $smarty->assign('PGB_CAP_EMAIL',     _PGB_CAP_EMAIL);
   $smarty->assign('PGB_CAP_MESSAGE',   _PGB_CAP_MESSAGE);
   $smarty->assign('PGB_CAP_CHANGE',    _PGB_CAP_CHANGE);
   $smarty->assign('PGB_CAP_CANCEL',    _PGB_CAP_CANCEL);
   $smarty->assign('PGB_CAP_PREVIEW',   _PGB_CAP_PREVIEW);
   $smarty->assign('PGB_CAP_SIGN',      _PGB_CAP_SIGN);
   $smarty->assign('PGB_CAP_DISABLE_BBCODE',    _PGB_CAP_DISABLE_BBCODE);
   $smarty->assign('PGB_CAP_DISABLE_HTML',      _PGB_CAP_DISABLE_HTML);
   $smarty->assign('PGB_CAP_DISABLE_AUTOLINKS', _PGB_CAP_DISABLE_AUTOLINKS);
   $smarty->assign('PGB_CAP_COMMENT', _PGB_CAP_COMMENT);

   $smarty->assign('PGB_CAP_REQUIRED_MSG', _PGB_CAP_REQUIRED_MSG);

   return $smarty;
}

/**
* function to be called from smarty if template was not found.
*/
function postguestbook_view_tplnotfound($resource_type, $resource_name, &$template_source, &$template_timestamp, &$this)
{
   //die("Resource wurde nicht gefunden: name=$resource_name\n type=$resource_type\n source=$template_source\n timestamp=$template_timestamp\n");
   //die("Smarty Template [$resource_name] not found");

   $template_source = "template was not found [$resource_name]<br />";
   $template_timestamp = time();

   return true;
}
?>
